
#include <stdio.h>
#include <stdarg.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

int dflag;

static int
vreport(char *type, char *fmt, va_list vp)
{
	int oerrno;
	int n;
	oerrno = errno;
	n = fprintf(stderr, "%s: ", type);
	n += vfprintf(stderr, fmt, vp);
	if(oerrno != 0)
		n += fprintf(stderr, ": %s", strerror(errno));
	n += fprintf(stderr, "\n");
	return n;
}

int
error(char *fmt, ...)
{
	va_list vp;
	va_start(vp, fmt);
	vreport("error", fmt, vp);
	va_end(vp);
	exit(1);
}

int
warn(char *fmt, ...)
{
	va_list vp;
	int r;
	va_start(vp, fmt);
	r = vreport("warn", fmt, vp);
	va_end(vp);
	errno = 0;
	return r;
}

int
info(char *fmt, ...)
{
	va_list vp;
	int r;
	if(!dflag)
		return 0;
	va_start(vp, fmt);
	r = vreport("info", fmt, vp);
	va_end(vp);
	errno = 0;
	return r;
}
